const fs = require( 'fs-extra' );
const path = require( 'path' );
const dnsSync = require( 'dns-sync' );
const Mustache = require( 'mustache' );
const Nations = require('./Nations.js')
const Setup = {};

const nationsync = Nations.updateChains()

if (nationsync.status!=200){
	console.log( '\x1b[31m Check your internet access, to setup this town we need to update the Nations. It seems we cannot do it' );
	process.exit();
}
if( !fs.existsSync( '/etc/nginx/nginx.conf' ) ) {
	console.log( '\x1b[31m Check documentation, nginx have to be installed on this server first, no /etc/nginx/nginx.conf available' );
	process.exit();
}
if( !fs.existsSync( './nationchains/tribes/index/conf.json' ) ){
	console.log( `\x1b[42m####################################\nWellcome into apxtrib, this is a first install.\nWe need to make this server accessible from internet subdomain.domain to current IP. This setup will create your unique tribeid, with an admin login user to let you connect to the parameter interface.\nCheck README's project to learn more. more.\n#####################################\x1b[0m` );
	const townSetup = fs.readJsonSync( './app/setup/townSetup.json') ;
	console.log( `Current setup conf from :./app/setup/townSetup.json\nChange with relevant setup data and rerun yarn setup` ) ;
	console.log( townSetup )
	const readline = require( 'readline' );
	const rl = readline.createInterface( {
		input: process.stdin,
		output: process.stdout
	} );
	rl.question( 'This is the data from ./app/setup/townSetup.json used, is it correct to use as first install (Yes/no)?', function ( rep1 ) {
		let quest = `This is a production install, please check that ${townSetup.townName}.${townSetup.nationName}.${townSetup.dns} IP is well redirect to tour server`;
		if( rep1 !== "Yes" ) process.exit( 0 );
		if( townSetup.dns == 'unchain' ) {
			quest = `This is a development installation, please add in your /etc/hosts 127.0.0.1 ${townSetup.townName}.${townSetup.nationName}.${townSetup.dns} `;
		}
		rl.question( quest + '\nAre you sure to set this? (Yes/no)', function ( rep2 ) {
			if( rep2 == "Yes" ) {
				const Checkjson = Setup.check( townSetup );
				if( Checkjson == "" ) {
					const townconf=fs.readJsonSync('./app/setup/townconf.json')
					// create tribes folder with townconf.json
					const towndata={...townSetup,...townconf};
					const Towns = require('./Towns');
					const Tribes = require('./Tribes');
					const Pagans = require('./Pagans');
					if (!towndata.mayorid ) Pagans.create

					Towns.create('./nationchains','./nationchains','towns',{...townSetup,...townconf});
					//Nationschains.create(townSetup);
                    Tribes.create(townSetup);
				    	
					// creer un lien symbolique vers /nationchains/ pour traiter les demandes via xworkon comme une tribe
					//Setup.config( townSetup );
				} else {
					console.log( check );
				}
			} else {
				console.log( 'Nothing done please, check setup/configsetup.json and  answer twice Yes' )
			}
			rl.close();
		} );
	} );
	rl.on( 'close', function () {
		console.log( '\n Setup process ended' );
		process.exit( 0 );
	} );
} else {
	console.log( 'Carefull you have already a config.js that is running. If you want to change remove config.js file and run again yarn setup' );
}

Setup.Checkjson = conf => {
	var rep = "";
    const nation_town=fs.readJsonSync('./nationchains/socialworld/objects/towns/searchindex/towns_nation_uuid.json');
	if (!ObjectKeys(nation_town).includes(conf.nationName)){
		rep+=`your nationName ${conf.nationName} does not exist you have to choose an existing one`;
	}
	if (nation_town[conf.nationName].includes(conf.townName)){
		rep+=`This conf.townName already exist you have to find a unique town name per nation`;
	}
	const getnation = Odmdb.get('./nationchains/socialworld/objects','towns',[conf.NationName],[nationId])
	//if getnation.data.notfound
	conf.language.forEach( l => {
		if( ![ "fr", "en", "it", "de", "sp" ].includes( l ) ) {
			rep += l + " Only fr,en,it,de,sp are available \n";
		}
	} );
	if( !fs.existsSync( `/home/${conf.sudoerUser}` ) ) {
		rep += `/home/${conf.sudoerUser} does not exist, user has to be create with a /home on this server\n`;
	}
	try {
		if ("true"== execSync("timeout 2 sudo id && sudo=\"true\" || sudo=\"false\";echo \"$sudo\"").toString().trim().split(/\r?\n/).slice(-1)) {
			rep+=`${sudoerUser} is not sudoer please change this `;
		} ;
	}catch(err){
		console.log(err);
		rep+=" Check your user it seems to not be a sudoer"
	}
	if( conf.jwtsecret.length < 32 ) {
		rep += "Your jwtsecretkey must have at least 32 characters"
	}
	if( conf.dns != 'unchain' && !dnsSync.resolve( `${conf.townName}.${conf.nationName}.${conf.dns}` ) ) {
		rep += `\nresolving $${conf.townName}.${conf.nationName}.${conf.dns} will not responding valid IP, please setup domain redirection IP before runing this script`
	}
	return rep
};

Setup.config = ( townSetup ) => {
	// Init this instance with a .config.js
	Setup.configjs( townSetup );
	// Create tribeid space + a user admin + webspace withe apxtrib webapp install
	Setup.druidid( townSetup );
};
Setup.configjs = ( townSetup ) => {
	// Set /config.js
	let confapxtrib = fs.readFileSync( './setup/config.mustache', 'utf-8' );
	fs.writeFileSync( './config.js', Mustache.render( confapxtrib, townSetup ), 'utf-8' );
	if( fs.existsSync( './config.js' ) ) {
		console.log( 'config.js successfully created.' );
	} else {
		console.log( "config.js not created, check what's wrong in tpl:", confapxtrib );
		console.log( "for data :", townSetup );
		process.exit();
	}
};
Setup.druidid = ( townSetup ) => {
	// create a tribeid with a user that will admin this instance into /tribes/tribeid /users
	const config = require( '../config.js' );
	// Need to do it on setup this is also done again in models/Tribes.js
	console.log( `${config.tribes}/${townSetup.druidid}` )
	fs.ensureDirSync( `${config.tribes}/${townSetup.druidid}` );
		[ 'users', 'www', 'referentials', 'nationchains' ].forEach( r => {
		fs.copySync( `${__base}/setup/tribes/apxtrib/${r}`, `${config.tribes}/${townSetup.druidid}/${r}` );
	} )
	/*	const confcli = JSON.parse( Mustache.render( fs.readFileSync( `${__base}/setup/tribes/apxtrib/clientconf.mustache`, 'utf8' ), townSetup ) );
		fs.outputJsonSync( `${config.tribes}/${townSetup.druidid}/clientconf.json`, confcli );
		// Create a new tribeid + admin user for this tribeid
		// with access to {druidid}:webapp as admin
	*/
	const Tribes = require( '../models/Tribes.js' );
	const access = { app: {}, data: {} }
	access.app[ `${townSetup.druidid}:webapp` ] = "admin";
	access.data[ townSetup.druidid ] = { "users": "CRUDO", "referentials": "CRUDO", "www": "CRUDO" };
	const createclient = Tribes.create( {
		tribeid: townSetup.druidid,
		genericpsw: townSetup.genericpsw,
		lanquageReferential: townSetup.language,
		useradmin: {
			LOGIN: townSetup.login,
			xlang: townSetup.language[ 0 ],
			ACCESSRIGHTS: access
		}
	} );
	if( createclient.status == 200 ) {
		console.log( `Your tribeid domain was created with login : ${townSetup.login} and password: ${townSetup.genericpsw}, change it after the 1st login on https://${townSetup.subdomain}.${townSetup.domain}` );
		// Create nginx conf for a first install
		const confnginx = fs.readFileSync( './setup/nginx/nginx.conf.mustache', 'utf8' );
		fs.outputFileSync( '/etc/nginx/nginx.conf', Mustache.render( confnginx, townSetup ), 'utf-8' );
		// Create a spacedev for webapp of apxtrib
		// that will be accesible in prod from https://subdomain.domain/ and in dev http://webapp.local.fr
		const addspaceweb = Tribes.addspaceweb( {
			setup: true,
			dnsname: [ `${townSetup.subdomain}.${townSetup.domain}` ],
			mode: townSetup.mode,
			tribeid: townSetup.druidid,
			website: 'webapp',
			pageindex: "app_index_fr.html"
		} );
		if( addspaceweb.status == 200 ) {
			console.log( `WELL DONE run yarn dev to test then yarn startpm2 ` )
		}
	} else {
		console.log( 'Issue ', createclient )
	}
}

module.exports = Setup;
