const fs = require( 'fs-extra' );
const path = require( 'path' );
const glob = require( 'glob' );
const moment = require( 'moment' );
// Check if package is installed or not to pickup the right config file
//const config = require( '../tribes/townconf.js' );
const config={}

const Tags = {};
/*
Keyword definition:

id:  b64 encoded field that can be : email , uuid
tribeid: apiamaildigit client Id, (a folder /tribes/tribeid have to exist)
email: identifiant of a person
uuid: identifiant o
 contact database
operationId: code name of an operation
messageId: code name of an templatesource have to exist in /datashared/templatesource/generic/messageId

*/
/*
Manage tag data collection
Popup survey manager
*/
Tags.info = ( data, req ) => {
	//console.log('headers:', req.headers)
	/*console.log('hostname', req.hostname)
	console.log('req.ip', req.ip)
	console.log('req.ips', req.ips)
	console.log('req key', Object.keys(req))
	*/
	//console.log('req.rawHeaders', req.body)
	data.useragent = `${req.headers['user-agent']}__${req.headers['accept-language']}__${req.headers['accept-encoding']}__${req.headers['connection']}`;
	data.ips = req.ips;
	data.ip = req.ip;
	data.proxyip = req.connection.remoteAddress;
	data.cookie = ""
	Object.keys( req.headers )
		.forEach( k => {
			if( ![ 'user-agent', 'accept-language', 'accept-encoding', 'connection' ].includes( k ) ) {
				data.cookie += `${k}__${req.headers['cookie']}|`
			}
		} )
	//data.cookie = `${req.headers['cookie']}__${req.headers['upgrade-insecure-requests']}__${req.headers['if-modified-since']}__${req.headers['if-no-match']}__${req.headers['cache-control']}`;
	return data
}
Tags.getfile = ( filename, req ) => {
	const infotg = filename.split( '__' );
	if( infotg.length < 3 && !fs.existsSync( `${config.tribes}/${infotg[1]}` ) ) {
		return {
			status: 400,
			payload: { info: [ 'fileUnknown' ], model: 'UploadFiles' }
		}
	}
	if( infotg[ 0 ] == "imgtg" ) {
		fs.outputJson( `${config.tribes}/${infotg[1]}/tags/imgtg/${Date.now()}.json`, Tags.info( { filename: filename, messageId: infotg[ 2 ], operationId: infotg[ 3 ], identifiant: infotg[ 4 ] }, req ), function ( err ) {
			if( err ) {
				console.log( `Erreur de sauvegarde de tag:${filename}` )
			}
		} );
		return {
			status: 200,
			payload: { moreinfo: "Declenche tag", filename: `${__base}/public/imgtg.png` }
		}
	}
	return { status: 404, payload: {} }
}
Tags.savehits = ( req ) => {
	if( !fs.existsSync( `${config.tribes}/${req.params.tribeid}` ) ) {
		console.log( `Erreur d'envoi de tag sur ${req.params.tribeid} pour ${req.params.r}` );
		return false;
	} else {
		const info = JSON.parse( JSON.stringify( req.body ) );
		fs.outputJson( `${config.tribes}/${req.params.tribeid}/tags/hits/${Date.now()}.json`, Tags.info( info, req ), function ( err ) {
			if( err ) {
				console.log( `Erreur de sauvegarde de tag pour ${req.params.tribeid} check si /tags/hits et /tags/imgtg exist bien ` )
			}
		} );
	}
	return true;
}
Tags.dataloadstat = ( tribeid ) => {
	/*
	@TODO à appeler via une route pour agregation de tag
	@TODO ajouter la suppression des fichiers hits traités qd le prog aura fait ses preuves en prod
	@TODO corriger la prod pour que l'ip passe

	Si on recharge plusieurs fois un hits (on ne le comptabilise pas si même r et même timestamps)

	Manage tag info to agregate by user and by statistique
	stats/data.json = {r:{
	                      info:{useragent:"",ip:[]},
	                      data:[ [timestamps, tit, cookie] ]
	                      }
	                    }
	stats/graph.json = {"graphYears": {AAAA:#visites,"years":[AAAA,AAAA]},
	                     "graphMonths": {AAAA:{"Jan":#visites,..},"monthsLabels":["Jan",..],"years":[AAAA,]},
	                     "graphDaysOfWeek":{"labels":["Sun","Mon",...],"Sun":#visites},
	                     "graphHoursOfDay":{"labels":["OOh","01h",...],"00h":#visites}
	                    }
	 Pour tester des evolutions ou un client en dev (recuperer son repertoire de prod /tags )
	  ajouter Tags.dataloadstat('yes');
	  NODE_ENV=dev node ./models/Tags.js
	*/
	const agrege = {
		data: {},
		graph: {
			visites: {
				graphYears: { years: [] },
				graphMonths: {
					years: [],
					monthsLabels: []
				},
				graphMonths: {
					years: [],
					monthsLabels: []
				},
				graphDayOfWeek: { labels: [] },
				graphHourOfDay: { labels: [] }
			},
			visitors: {
				graphMonths: {
					years: [],
					monthsLabels: []
				}
			}
		}
	};
	try {
		agrege.data = fs.readJsonSync( `${config.tribes}/${tribeid}/tags/stats/data.json`, "utf-8" );
		agrege.graph = fs.readJsonSync( `${config.tribes}/${tribeid}/tags/stats/graph.json`, "utf-8" );
	} catch ( err ) {
		console.log( "ATTENTION tag reinitialisé en data.json et graph.json, s'il s'agit de 1ere connexion pas de pb. Le risque est de perdre les tag historiques" )
		//return { status: 503, payload: { info: ['Errconfig'], model: 'Tags', moreinfo: `Il manque un ${config.tribes}/${tribeid}/tags/stats/data.json ou stats/graph.json` } }
	}
	glob.sync( `${config.tribes}/${tribeid}/tags/hits/*` )
		.forEach( f => {
			const hit = fs.readJsonSync( f );
			const ts = parseInt( path.basename( f )
				.split( ".json" )[ 0 ] );
			//console.log(moment(ts).format('DD-MM-YYYY h:mm:ss'));
			const tsm = moment( ts )
			const year = tsm.format( 'YYYY' );
			const month = tsm.format( 'MMM' );
			const dayow = tsm.format( 'ddd' );
			const hourod = tsm.format( 'HH' ) + "h";
			let newvisitor = false;
			let alreadydone = false;
			//console.log(hit.r, ts)
			// Agrege data pour # visiteur vs # de visiteur
			if( agrege.data[ hit.r ] ) {
				if( !agrege.data[ hit.r ].data.some( el => el[ 0 ] == ts ) ) {
					//evite de charger plusieurs fois le même
					agrege.data[ hit.r ].data.push( [ ts, hit.tit, hit.cookie ] )
				} else {
					alreadydone = true;
				}
			} else {
				newvisitor = true;
				agrege.data[ hit.r ] = {
					info: { useragent: hit.useragent, ip: [ hit.ip ] },
					data: [
            [ ts, hit.tit, hit.cookie ]
          ]
				}
			}
			if( !alreadydone ) {
				if( newvisitor ) {
					//traite Month
					if( !agrege.graph.visitors.graphMonths[ year ] ) {
						agrege.graph.visitors.graphMonths[ year ] = {}
						agrege.graph.visitors.graphMonths.years.push( year )
					}
					if( agrege.graph.visitors.graphMonths[ year ][ month ] ) {
						agrege.graph.visitors.graphMonths[ year ][ month ] += 1
					} else {
						agrege.graph.visitors.graphMonths[ year ][ month ] = 1
						agrege.graph.visitors.graphMonths.monthsLabels.push( month )
					}
				}
				//traite graphe Year #visite
				if( agrege.graph.visites.graphYears[ year ] ) {
					agrege.graph.visites.graphYears[ year ] += 1
				} else {
					agrege.graph.visites.graphYears[ year ] = 1
					agrege.graph.visites.graphYears.years.push( year )
					agrege.graph.visites.graphMonths[ year ] = {}
					agrege.graph.visites.graphMonths.years.push( year )
				}
				//traite graphe Month
				if( agrege.graph.visites.graphMonths[ year ][ month ] ) {
					agrege.graph.visites.graphMonths[ year ][ month ] += 1
				} else {
					agrege.graph.visites.graphMonths[ year ][ month ] = 1
					agrege.graph.visites.graphMonths.monthsLabels.push( month )
				}
				//traite graphe Days of week
				if( agrege.graph.visites.graphDayOfWeek[ dayow ] ) {
					agrege.graph.visites.graphDayOfWeek[ dayow ] += 1
				} else {
					agrege.graph.visites.graphDayOfWeek[ dayow ] = 1
					agrege.graph.visites.graphDayOfWeek.labels.push( dayow )
				}
				//traite graphe Hour of day
				if( agrege.graph.visites.graphHourOfDay[ hourod ] ) {
					agrege.graph.visites.graphHourOfDay[ hourod ] += 1
				} else {
					agrege.graph.visites.graphHourOfDay[ hourod ] = 1
					agrege.graph.visites.graphHourOfDay.labels.push( hourod )
				}
			}
		} )
	fs.outputJsonSync( `${config.tribes}/${tribeid}/tags/stats/data.json`, agrege.data, 'utf-8' );
	fs.outputJsonSync( `${config.tribes}/${tribeid}/tags/stats/graph.json`, agrege.graph, 'utf-8' );
	return { status: 200, payload: { info: [ 'Statsupdated' ], model: 'Tags' } }
}
//console.log(Tags.dataloadstat('yes'));
/*const ar = [
  [1, 1],
  [1, 2]
]
console.log(ar.some(el => el[0] == 1 && el[1] == 1))
console.log(ar.some(el => el == [1, 3]))
*/
Tags.nginxlog=(pathFile)=>{
	/*
	Read an nginx log file and return
	@TODO standardiser le log nginx pour recuperer des données (IP,...) 
	@return {visites:{year:month:{day:number of visites}},
             visitors:{year:month:{day: number of unique visitors for the day}}
			                year: number of unique visitors for the year}
							month:month : number of unique visitors for the month]
			}
	*/
	const log=	fs.readFileSync(pathFile,'utf-8');
	const logs=log.split('\n');
	console.log(`nombre ligne ${logs.length}`)
	const stat={visits:{},visitors:{}};
	const visitor={}
	var previousdt=moment();
	var previoususeragent="";
	console.log(moment(previousdt).format('DD/MMM/YYYY:hh:mm:ss'))
	logs.forEach(l=>{
		const elt= l.split('##');
		const useragent = (elt[2] && elt[2].split("\" \"")[1]) ? elt[2].split("\" \"")[1]:"unknown";
		//elt[0] = [30/Jun/2022:15:15:53 +0200]
		const dttime = moment(elt[0].split(' ')[0].substring(1),'DD/MMM/YYYY:hh:mm:ss');
		['visits','visitors'].forEach(ch=>{
			if (!stat[ch][dttime.format('YYYY')]) stat[ch][dttime.format('YYYY')]={};
			if (!stat[ch][dttime.format('YYYY')][dttime.format('MMM')]) stat[ch][dttime.format('YYYY')][dttime.format('MMM')]={}
			if (!stat[ch][dttime.format('YYYY')][dttime.format('MMM')][dttime.format('DD')]) stat[ch][dttime.format('YYYY')][dttime.format('MMM')][[dttime.format('DD')]]=0
			if (!visitor[dttime.format('YYYY')]) visitor[dttime.format('YYYY')]={};
			if (!visitor[dttime.format('YYYY')][dttime.format('MMM')]) visitor[dttime.format('YYYY')][dttime.format('MMM')]={}
			if (!visitor[dttime.format('YYYY')][dttime.format('MMM')][dttime.format('DD')]) visitor[dttime.format('YYYY')][dttime.format('MMM')][[dttime.format('DD')]]=[]
		})
		//console.log(elt[0].split(' ')[0]+ "####" + moment(elt[0],'DD/MMM/YYYY:hh:mm:ss').format('DD-MM-YYYY h:mm:ss'));
	    //console.log("EEEE"+moment(previousdt).format('DD/MMM/YYYY:hh:mm:ss') + "hhhhhhh" +moment(dttime).format('DD/MMM/YYYY:hh:mm:ss'))
		//console.log(previousdt!=dttime)
		if (!visitor[dttime.format('YYYY')][dttime.format('MMM')][dttime.format('DD')].includes(useragent)){
			visitor[dttime.format('YYYY')][dttime.format('MMM')][dttime.format('DD')].push(useragent)
		}
		if (previoususeragent != useragent || parseInt(Math.round(previousdt.toDate().getTime()/100000)) != parseInt(Math.round(dttime.toDate().getTime()/100000))) {
			/*console.log("###########################################################");
			console.log(`${previousdt.toDate().getTime()} != ${dttime.toDate().getTime()}`);
			console.log(moment(previousdt).format('DD/MMM/YYYY:hh:mm:ss') + "hhhhhhh" +  moment(dttime).format('DD/MMM/YYYY:hh:mm:ss'))
			console.log(`useragent: ${useragent} previoususeragent: ${previoususeragent}`);
			*/
			stat['visits'][dttime.format('YYYY')][dttime.format('MMM')][[dttime.format('DD')]]+=1
			previousdt=dttime;
			previoususeragent=useragent;
		}else{
			//console.log("identique compte pas" )
		}
	})
	Object.keys(visitor).forEach(y=>{
		var uniqvisitoryear=[];
		Object.keys(visitor[y]).forEach(m=>{
			var uniqvisitormonth=[];
			Object.keys(visitor[y][m]).forEach(d=>{
				uniqvisitormonth = [...uniqvisitormonth, ...visitor[y][m][d]]
				stat.visitors[y][m][d] = visitor[y][m][d].length
			})
			uniqvisitoryear=[...uniqvisitoryear, ...uniqvisitormonth]
			stat.visitors[y][m][m]=uniqvisitormonth.length;
		})
		stat.visitors[y][y]=uniqvisitoryear.length
	})
	return {status:200, data:stat}
}
Tags.statin2D=(stat,pathfile)=>{
	if (stat.status==200){
		stat=stat.data
	}else {
		return stat
	}
  let csv="type;year;month;day;Number\n\r";
  ["visits", "visitors"].forEach(ch=>{
	Object.keys(stat[ch]).forEach(y=>{
		Object.keys(stat[ch][y]).forEach(m=>{
			Object.keys(stat[ch][y][m]).forEach(d=>{
				csv+=`${ch};${y};${m};${d};${stat[ch][y][m][d]}\n\r`
			})
		})
	})
  })
  fs.outputFileSync(pathfile,csv);
  return {status:200, info:"fileready", moreinfo:pathfile}
}
console.log(Tags.statin2D(Tags.nginxlog('/home/phil/Documents/nginx/presentation.capsthd.access.log'),'/home/phil/Documents/nginx/stat.csv'));
module.exports = Tags;
